"""pybind meshing module"""
from __future__ import annotations
import netgen.libngpy._meshing
import typing
import numpy
import os
import pyngcore.pyngcore

__all__ = [
    "Array_N6netgen14FaceDescriptorE_S",
    "Array_N6netgen7ElementE_N6netgen12ElementIndexE",
    "Array_N6netgen7SegmentE_N6netgen12SegmentIndexE",
    "Array_N6netgen9Element0dE_S",
    "Array_N6netgen9Element2dE_N6netgen19SurfaceElementIndexE",
    "Array_N6netgen9MeshPointE_N6netgen10PointIndexE",
    "ClearSolutionClass",
    "Element0D",
    "Element1D",
    "Element2D",
    "Element3D",
    "ElementId1D",
    "ElementId2D",
    "ElementId3D",
    "FaceDescriptor",
    "FlatArray_N6netgen14FaceDescriptorE_S",
    "FlatArray_N6netgen7ElementE_N6netgen12ElementIndexE",
    "FlatArray_N6netgen7SegmentE_N6netgen12SegmentIndexE",
    "FlatArray_N6netgen9Element0dE_S",
    "FlatArray_N6netgen9Element2dE_N6netgen19SurfaceElementIndexE",
    "FlatArray_N6netgen9MeshPointE_N6netgen10PointIndexE",
    "GetTransformation",
    "IdentificationType",
    "ImportMesh",
    "MPI_Comm",
    "Mesh",
    "MeshPoint",
    "MeshingParameters",
    "MeshingStep",
    "NGDummyArgument",
    "NetgenGeometry",
    "NgException",
    "Pnt",
    "Point2d",
    "Point3d",
    "PointId",
    "ReadCGNSFile",
    "SetMessageImportance",
    "SetParallelPickling",
    "SetTestoutFile",
    "SetTransformation",
    "SurfaceGeometry",
    "Trafo",
    "Vec",
    "Vec2d",
    "Vec3d",
    "WriteCGNSFile",
    "debugparam"
]


class FlatArray_N6netgen14FaceDescriptorE_S():
    def __getitem__(self, arg0: int) -> FaceDescriptor: ...
    def __iter__(self) -> typing.Iterator[FaceDescriptor]: ...
    def __len__(self) -> int: ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: FaceDescriptor) -> FaceDescriptor: ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: FaceDescriptor) -> None: ...
    def __str__(self) -> str: ...
    pass
class FlatArray_N6netgen7ElementE_N6netgen12ElementIndexE():
    def NumPy(self) -> object: ...
    def __getitem__(self, arg0: ElementId3D) -> Element3D: ...
    def __iter__(self) -> typing.Iterator[Element3D]: ...
    def __len__(self) -> int: ...
    @typing.overload
    def __setitem__(self, arg0: ElementId3D, arg1: Element3D) -> Element3D: ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Element3D) -> None: ...
    def __str__(self) -> str: ...
    pass
class FlatArray_N6netgen7SegmentE_N6netgen12SegmentIndexE():
    def NumPy(self) -> object: ...
    def __getitem__(self, arg0: ElementId1D) -> Element1D: ...
    def __iter__(self) -> typing.Iterator[Element1D]: ...
    def __len__(self) -> int: ...
    @typing.overload
    def __setitem__(self, arg0: ElementId1D, arg1: Element1D) -> Element1D: ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Element1D) -> None: ...
    def __str__(self) -> str: ...
    pass
class FlatArray_N6netgen9Element0dE_S():
    def __getitem__(self, arg0: int) -> Element0D: ...
    def __iter__(self) -> typing.Iterator[Element0D]: ...
    def __len__(self) -> int: ...
    @typing.overload
    def __setitem__(self, arg0: int, arg1: Element0D) -> Element0D: ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Element0D) -> None: ...
    def __str__(self) -> str: ...
    pass
class FlatArray_N6netgen9Element2dE_N6netgen19SurfaceElementIndexE():
    def NumPy(self) -> object: ...
    def __getitem__(self, arg0: ElementId2D) -> Element2D: ...
    def __iter__(self) -> typing.Iterator[Element2D]: ...
    def __len__(self) -> int: ...
    @typing.overload
    def __setitem__(self, arg0: ElementId2D, arg1: Element2D) -> Element2D: ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: Element2D) -> None: ...
    def __str__(self) -> str: ...
    pass
class FlatArray_N6netgen9MeshPointE_N6netgen10PointIndexE():
    def __getitem__(self, arg0: PointId) -> MeshPoint: ...
    def __iter__(self) -> typing.Iterator[MeshPoint]: ...
    def __len__(self) -> int: ...
    @typing.overload
    def __setitem__(self, arg0: PointId, arg1: MeshPoint) -> MeshPoint: ...
    @typing.overload
    def __setitem__(self, arg0: slice, arg1: MeshPoint) -> None: ...
    def __str__(self) -> str: ...
    pass
class ClearSolutionClass():
    def __init__(self) -> None: ...
    pass
class Element0D():
    def __init__(self, vertex: PointId, index: int = 1) -> None: 
        """
        create point element
        """
    def __repr__(self) -> str: ...
    @property
    def vertices(self) -> list:
        """
        :type: list
        """
    pass
class Element1D():
    def __init__(self, vertices: list, surfaces: list = [], index: int = 1, edgenr: int = 1, trignums: list = []) -> None: 
        """
        create segment element
        """
    def __repr__(self) -> str: ...
    @property
    def edgenr(self) -> int:
        """
        :type: int
        """
    @property
    def index(self) -> int:
        """
        :type: int
        """
    @property
    def points(self) -> list:
        """
        :type: list
        """
    @property
    def surfaces(self) -> list:
        """
        :type: list
        """
    @property
    def vertices(self) -> list:
        """
        :type: list
        """
    pass
class Element2D():
    @staticmethod
    def __init__(*args, **kwargs) -> typing.Any: 
        """
        create surface element
        """
    @property
    def curved(self) -> bool:
        """
        :type: bool
        """
    @curved.setter
    def curved(self, arg1: bool) -> None:
        pass
    @property
    def index(self) -> int:
        """
        :type: int
        """
    @index.setter
    def index(self, arg1: int) -> None:
        pass
    @property
    def points(self) -> list:
        """
        :type: list
        """
    @property
    def vertices(self) -> list:
        """
        :type: list
        """
    pass
class Element3D():
    @staticmethod
    def __init__(*args, **kwargs) -> typing.Any: 
        """
        create volume element
        """
    def __repr__(self) -> str: ...
    @property
    def curved(self) -> bool:
        """
        :type: bool
        """
    @curved.setter
    def curved(self, arg1: bool) -> None:
        pass
    @property
    def index(self) -> int:
        """
        :type: int
        """
    @index.setter
    def index(self, arg1: int) -> None:
        pass
    @property
    def points(self) -> list:
        """
        :type: list
        """
    @property
    def vertices(self) -> list:
        """
        :type: list
        """
    pass
class ElementId1D():
    def __eq__(self, arg0: ElementId1D) -> bool: ...
    def __hash__(self) -> int: ...
    def __init__(self, arg0: int) -> None: ...
    def __repr__(self) -> str: ...
    def __str__(self) -> str: ...
    @property
    def nr(self) -> int:
        """
        :type: int
        """
    pass
class ElementId2D():
    def __eq__(self, arg0: ElementId2D) -> bool: ...
    def __hash__(self) -> int: ...
    def __init__(self, arg0: int) -> None: ...
    def __repr__(self) -> str: ...
    def __str__(self) -> str: ...
    @property
    def nr(self) -> int:
        """
        :type: int
        """
    pass
class ElementId3D():
    def __eq__(self, arg0: ElementId3D) -> bool: ...
    def __hash__(self) -> int: ...
    def __init__(self, arg0: int) -> None: ...
    def __repr__(self) -> str: ...
    def __str__(self) -> str: ...
    @property
    def nr(self) -> int:
        """
        :type: int
        """
    pass
class FaceDescriptor():
    @typing.overload
    def __init__(self, arg0: FaceDescriptor) -> None: 
        """
        create facedescriptor
        """
    @typing.overload
    def __init__(self, surfnr: int = 1, domin: int = 1, domout: int = 0, bc: int = 0) -> None: ...
    def __repr__(self) -> str: ...
    def __str__(self) -> str: ...
    @property
    def bc(self) -> int:
        """
        :type: int
        """
    @bc.setter
    def bc(self, arg1: int) -> None:
        pass
    @property
    def bcname(self) -> str:
        """
        :type: str
        """
    @bcname.setter
    def bcname(self, arg1: str) -> None:
        pass
    @property
    def color(self) -> tuple:
        """
        :type: tuple
        """
    @color.setter
    def color(self, arg1: tuple) -> None:
        pass
    @property
    def domin(self) -> int:
        """
        :type: int
        """
    @domin.setter
    def domin(self, arg1: int) -> None:
        pass
    @property
    def domout(self) -> int:
        """
        :type: int
        """
    @domout.setter
    def domout(self, arg1: int) -> None:
        pass
    @property
    def surfnr(self) -> int:
        """
        :type: int
        """
    @surfnr.setter
    def surfnr(self, arg1: int) -> None:
        pass
    @property
    def transparency(self) -> float:
        """
        :type: float
        """
    @transparency.setter
    def transparency(self, arg1: float) -> None:
        pass
    pass
class Array_N6netgen14FaceDescriptorE_S(FlatArray_N6netgen14FaceDescriptorE_S):
    def __getstate__(self) -> tuple: ...
    @typing.overload
    def __init__(self, n: int) -> None: 
        """
        Makes array of given length

        Makes array with given list of elements
        """
    @typing.overload
    def __init__(self, vec: list[FaceDescriptor]) -> None: ...
    def __setstate__(self, arg0: tuple) -> None: ...
    pass
class Array_N6netgen7ElementE_N6netgen12ElementIndexE(FlatArray_N6netgen7ElementE_N6netgen12ElementIndexE):
    def __getstate__(self) -> tuple: ...
    @typing.overload
    def __init__(self, n: int) -> None: 
        """
        Makes array of given length

        Makes array with given list of elements
        """
    @typing.overload
    def __init__(self, vec: list[Element3D]) -> None: ...
    def __setstate__(self, arg0: tuple) -> None: ...
    pass
class Array_N6netgen7SegmentE_N6netgen12SegmentIndexE(FlatArray_N6netgen7SegmentE_N6netgen12SegmentIndexE):
    def __getstate__(self) -> tuple: ...
    @typing.overload
    def __init__(self, n: int) -> None: 
        """
        Makes array of given length

        Makes array with given list of elements
        """
    @typing.overload
    def __init__(self, vec: list[Element1D]) -> None: ...
    def __setstate__(self, arg0: tuple) -> None: ...
    pass
class Array_N6netgen9Element0dE_S(FlatArray_N6netgen9Element0dE_S):
    @typing.overload
    def __init__(self, n: int) -> None: 
        """
        Makes array of given length

        Makes array with given list of elements
        """
    @typing.overload
    def __init__(self, vec: list[Element0D]) -> None: ...
    pass
class Array_N6netgen9Element2dE_N6netgen19SurfaceElementIndexE(FlatArray_N6netgen9Element2dE_N6netgen19SurfaceElementIndexE):
    def __getstate__(self) -> tuple: ...
    @typing.overload
    def __init__(self, n: int) -> None: 
        """
        Makes array of given length

        Makes array with given list of elements
        """
    @typing.overload
    def __init__(self, vec: list[Element2D]) -> None: ...
    def __setstate__(self, arg0: tuple) -> None: ...
    pass
class Array_N6netgen9MeshPointE_N6netgen10PointIndexE(FlatArray_N6netgen9MeshPointE_N6netgen10PointIndexE):
    def __getstate__(self) -> tuple: ...
    @typing.overload
    def __init__(self, n: int) -> None: 
        """
        Makes array of given length

        Makes array with given list of elements
        """
    @typing.overload
    def __init__(self, vec: list[MeshPoint]) -> None: ...
    def __setstate__(self, arg0: tuple) -> None: ...
    pass
class IdentificationType():
    """
    Members:

      UNDEFINED

      PERIODIC

      CLOSESURFACES

      CLOSEEDGES
    """
    def __eq__(self, other: object) -> bool: ...
    def __getstate__(self) -> int: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __init__(self, value: int) -> None: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    def __repr__(self) -> str: ...
    def __setstate__(self, state: int) -> None: ...
    def __str__(self) -> str: ...
    @property
    def name(self) -> str:
        """
        :type: str
        """
    @property
    def value(self) -> int:
        """
        :type: int
        """
    CLOSEEDGES: netgen.libngpy._meshing.IdentificationType # value = <IdentificationType.CLOSEEDGES: 4>
    CLOSESURFACES: netgen.libngpy._meshing.IdentificationType # value = <IdentificationType.CLOSESURFACES: 3>
    PERIODIC: netgen.libngpy._meshing.IdentificationType # value = <IdentificationType.PERIODIC: 2>
    UNDEFINED: netgen.libngpy._meshing.IdentificationType # value = <IdentificationType.UNDEFINED: 1>
    __members__: dict # value = {'UNDEFINED': <IdentificationType.UNDEFINED: 1>, 'PERIODIC': <IdentificationType.PERIODIC: 2>, 'CLOSESURFACES': <IdentificationType.CLOSESURFACES: 3>, 'CLOSEEDGES': <IdentificationType.CLOSEEDGES: 4>}
    pass
class MPI_Comm():
    def Barrier(self) -> None: ...
    @typing.overload
    def Max(self, arg0: float) -> float: ...
    @typing.overload
    def Max(self, arg0: int) -> int: ...
    @typing.overload
    def Min(self, arg0: float) -> float: ...
    @typing.overload
    def Min(self, arg0: int) -> int: ...
    def SubComm(self, procs: list[int]) -> MPI_Comm: ...
    @typing.overload
    def Sum(self, arg0: float) -> float: ...
    @typing.overload
    def Sum(self, arg0: int) -> int: ...
    def WTime(self) -> float: ...
    @property
    def rank(self) -> int:
        """
        :type: int
        """
    @property
    def size(self) -> int:
        """
        :type: int
        """
    pass
class Mesh():
    @typing.overload
    def Add(self, arg0: Element0D) -> int: ...
    @typing.overload
    def Add(self, arg0: Element1D) -> ElementId1D: ...
    @typing.overload
    def Add(self, arg0: Element2D) -> ElementId2D: ...
    @typing.overload
    def Add(self, arg0: Element3D) -> ElementId3D: ...
    @typing.overload
    def Add(self, arg0: FaceDescriptor) -> int: ...
    @typing.overload
    def Add(self, arg0: MeshPoint) -> PointId: ...
    def AddElements(self, dim: int, index: int, data: Buffer, base: int = 0) -> None: ...
    def AddPointIdentification(self, pid1: object, pid2: object, identnr: int, type: IdentificationType = IdentificationType.PERIODIC) -> None: ...
    def AddPoints(self, arg0: Buffer) -> None: ...
    def AddRegion(self, name: str, dim: int) -> int: ...
    def BoundaryLayer(self, boundary: typing.Union[str, int], thickness: typing.Union[float, list], material: typing.Union[str, dict[str, str]], domains: typing.Union[str, int] = '.*', outside: bool = False, project_boundaries: typing.Optional[str] = None, grow_edges: bool = True, limit_growth_vectors: bool = True) -> None: 
        """
        Add boundary layer to mesh.

        Parameters
        ----------

        boundary : string or int
          Boundary name or number.

        thickness : float or List[float]
          Thickness of boundary layer(s).

        material : str or List[str]
          Material name of boundary layer(s).

        domain : str or int
          Regexp for domain boundarylayer is going into.

        outside : bool = False
          If true add the layer on the outside

        grow_edges : bool = False
          Grow boundary layer over edges.

        project_boundaries : Optional[str] = None
          Project boundarylayer to these boundaries if they meet them. Set
          to boundaries that meet boundarylayer at a non-orthogonal edge and
          layer-ending should be projected to that boundary.
        """
    def BoundaryLayer2(self, domain: int, thicknesses: pyngcore.pyngcore.Array_D_S, make_new_domain: bool = True, boundaries: pyngcore.pyngcore.Array_I_S = ...) -> int: ...
    def BuildSearchTree(self) -> None: ...
    def CalcLocalH(self, arg0: float, arg1: int) -> None: ...
    def CalcMinMaxAngle(self, badelement_limit: float = 175.0) -> dict: ...
    @staticmethod
    def CalcTotalBadness(*args, **kwargs) -> typing.Any: ...
    def Compress(self) -> None: ...
    def Coordinates(self) -> numpy.ndarray: ...
    def Copy(self) -> Mesh: ...
    def DeleteSurfaceElement(self, arg0: ElementId2D) -> None: ...
    def Distribute(self, comm: MPI_Comm) -> Mesh: ...
    def Elements0D(self) -> Array[Element0D]: ...
    def Elements1D(self) -> Array_N6netgen7SegmentE_N6netgen12SegmentIndexE: ...
    def Elements2D(self) -> Array_N6netgen9Element2dE_N6netgen19SurfaceElementIndexE: ...
    def Elements3D(self) -> Array_N6netgen7ElementE_N6netgen12ElementIndexE: ...
    def EnableTable(self, name: str, set: bool = True) -> None: ...
    @staticmethod
    def EnableTableClass(name: str, set: bool = True) -> None: ...
    def Export(self, filename: str, format: str) -> None: ...
    def FaceDescriptor(self, arg0: int) -> FaceDescriptor: ...
    def FaceDescriptors(self) -> Array[FaceDescriptor]: ...
    @staticmethod
    def GenerateVolumeMesh(*args, **kwargs) -> typing.Any: 
        """
        Meshing Parameters
        -------------------

        maxh: float = 1e10
          Global upper bound for mesh size.

        grading: float = 0.3
          Mesh grading how fast the local mesh size can change.

        meshsizefilename: str = None
          Load meshsize from file. Can set local mesh size for points
          and along edges. File must have the format:

            nr_points
            x1, y1, z1, meshsize
            x2, y2, z2, meshsize
            ...
            xn, yn, zn, meshsize

            nr_edges
            x11, y11, z11, x12, y12, z12, meshsize
            ...
            xn1, yn1, zn1, xn2, yn2, zn2, meshsize

        segmentsperedge: float = 1.
          Minimal number of segments per edge.

        quad_dominated: bool = False
          Quad-dominated surface meshing.

        blockfill: bool = True
          Do fast blockfilling.

        filldist: float = 0.1
          Block fill up to distance

        delaunay: bool = True
          Use delaunay meshing.

        delaunay2d : bool = True
          Use delaunay meshing for 2d geometries.

        Optimization Parameters
        -----------------------

        optimize3d: str = "cmdmustm"
          3d optimization strategy:
            m .. move nodes
            M .. move nodes, cheap functional
            s .. swap faces
            c .. combine elements
            d .. divide elements
            p .. plot, no pause
            P .. plot, Pause
            h .. Histogramm, no pause
            H .. Histogramm, pause

        optsteps3d: int = 3
          Number of 3d optimization steps.

        optimize2d: str = "smcmSmcmSmcm"
          2d optimization strategy:
            s .. swap, opt 6 lines/node
            S .. swap, optimal elements
            m .. move nodes
            p .. plot, no pause
            P .. plot, pause
            c .. combine

        optsteps2d: int = 3
          Number of 2d optimization steps.

        elsizeweight: float = 0.2
          Weight of element size w.r.t. element shape in optimization.
        """
    def GetBCName(self, arg0: int) -> str: ...
    def GetCD2Name(self, arg0: int) -> str: ...
    def GetCD3Name(self, arg0: int) -> str: ...
    def GetGeometry(self) -> NetgenGeometry: ...
    def GetMaterial(self, arg0: int) -> str: ...
    def GetNCD2Names(self) -> int: ...
    def GetNDomains(self) -> int: ...
    def GetNFaceDescriptors(self) -> int: ...
    def GetNrIdentifications(self) -> int: ...
    def GetQualityHistogram(self) -> pyngcore.pyngcore.FlatArray_I_S: ...
    def GetVolumeNeighboursOfSurfaceElement(self, arg0: int) -> tuple: 
        """
        Returns element nrs of volume element connected to surface element, -1 if no volume element
        """
    def IdentifyPeriodicBoundaries(self, face1: str, face2: str, mapping: Trafo, point_tolerance: float = -1.0) -> int: ...
    def Load(self, arg0: str) -> None: ...
    def Mirror(self, arg0: Point3d, arg1: Vec3d) -> Mesh: ...
    @staticmethod
    def OptimizeMesh2d(*args, **kwargs) -> typing.Any: ...
    @staticmethod
    def OptimizeVolumeMesh(*args, **kwargs) -> typing.Any: ...
    def Partition(self, numproc: int) -> None: ...
    def Points(self) -> Array_N6netgen9MeshPointE_N6netgen10PointIndexE: ...
    @staticmethod
    def Receive(comm: MPI_Comm) -> Mesh: ...
    def Refine(self) -> None: ...
    def Save(self, arg0: os.PathLike) -> None: ...
    def Scale(self, arg0: float) -> None: ...
    def SecondOrder(self) -> None: ...
    def SetBCName(self, arg0: int, arg1: str) -> None: ...
    def SetCD2Name(self, arg0: int, arg1: str) -> None: ...
    def SetCD3Name(self, arg0: int, arg1: str) -> None: ...
    def SetGeometry(self, arg0: NetgenGeometry) -> None: ...
    def SetMaterial(self, arg0: int, arg1: str) -> None: ...
    def SetMaxHDomain(self, arg0: list) -> None: ...
    def Update(self) -> None: ...
    def ZRefine(self, arg0: str, arg1: pyngcore.pyngcore.Array_D_S) -> None: ...
    @typing.overload
    def __getitem__(self, arg0: ElementId1D) -> Element1D: ...
    @typing.overload
    def __getitem__(self, arg0: ElementId2D) -> Element2D: ...
    @typing.overload
    def __getitem__(self, arg0: ElementId3D) -> Element3D: ...
    @typing.overload
    def __getitem__(self, arg0: PointId) -> MeshPoint: ...
    def __getstate__(self) -> tuple: ...
    def __init__(self, dim: int = 3, comm: MPI_Comm = ...) -> None: ...
    def __setitem__(self, arg0: PointId, arg1: MeshPoint) -> MeshPoint: ...
    def __setstate__(self, arg0: tuple) -> None: ...
    def _get2dElementsAsTriangles(self) -> pyngcore.pyngcore.Array_I_S: ...
    def _get3dElementsAsTets(self) -> pyngcore.pyngcore.Array_I_S: ...
    def _getSegments(self) -> pyngcore.pyngcore.Array_I_S: ...
    def _getVertices(self) -> pyngcore.pyngcore.Array_F_S: ...
    def _getWireframe(self) -> pyngcore.pyngcore.Array_I_S: ...
    @property
    def _timestamp(self) -> int:
        """
        :type: int
        """
    @property
    def comm(self) -> MPI_Comm:
        """
        MPI-communicator the Mesh lives in

        :type: MPI_Comm
        """
    @property
    def dim(self) -> int:
        """
        :type: int
        """
    @dim.setter
    def dim(self, arg1: int) -> None:
        pass
    @property
    def ne(self) -> int:
        """
        :type: int
        """
    pass
class MeshPoint():
    def __getitem__(self, arg0: int) -> float: ...
    def __init__(self, arg0: Point3d) -> None: ...
    def __repr__(self) -> str: ...
    def __setitem__(self, arg0: int, arg1: float) -> None: ...
    def __str__(self) -> str: ...
    @property
    def p(self) -> tuple:
        """
        :type: tuple
        """
    pass
class MeshingParameters():
    @typing.overload
    def RestrictH(self, p: Point3d, h: float) -> None: ...
    @typing.overload
    def RestrictH(self, x: float, y: float, z: float, h: float) -> None: ...
    def RestrictHLine(self, p1: Point3d, p2: Point3d, maxh: float) -> None: ...
    @typing.overload
    def __init__(self) -> None: 
        """
        Meshing Parameters
        -------------------

        maxh: float = 1e10
          Global upper bound for mesh size.

        grading: float = 0.3
          Mesh grading how fast the local mesh size can change.

        meshsizefilename: str = None
          Load meshsize from file. Can set local mesh size for points
          and along edges. File must have the format:

            nr_points
            x1, y1, z1, meshsize
            x2, y2, z2, meshsize
            ...
            xn, yn, zn, meshsize

            nr_edges
            x11, y11, z11, x12, y12, z12, meshsize
            ...
            xn1, yn1, zn1, xn2, yn2, zn2, meshsize

        segmentsperedge: float = 1.
          Minimal number of segments per edge.

        quad_dominated: bool = False
          Quad-dominated surface meshing.

        blockfill: bool = True
          Do fast blockfilling.

        filldist: float = 0.1
          Block fill up to distance

        delaunay: bool = True
          Use delaunay meshing.

        delaunay2d : bool = True
          Use delaunay meshing for 2d geometries.

        Optimization Parameters
        -----------------------

        optimize3d: str = "cmdmustm"
          3d optimization strategy:
            m .. move nodes
            M .. move nodes, cheap functional
            s .. swap faces
            c .. combine elements
            d .. divide elements
            p .. plot, no pause
            P .. plot, Pause
            h .. Histogramm, no pause
            H .. Histogramm, pause

        optsteps3d: int = 3
          Number of 3d optimization steps.

        optimize2d: str = "smcmSmcmSmcm"
          2d optimization strategy:
            s .. swap, opt 6 lines/node
            S .. swap, optimal elements
            m .. move nodes
            p .. plot, no pause
            P .. plot, pause
            c .. combine

        optsteps2d: int = 3
          Number of 2d optimization steps.

        elsizeweight: float = 0.2
          Weight of element size w.r.t. element shape in optimization.
        """
    @typing.overload
    def __init__(self, mp: MeshingParameters = None, **kwargs) -> None: ...
    def __str__(self) -> str: ...
    pass
class MeshingStep():
    """
    Members:

      ANALYSE

      MESHEDGES

      MESHSURFACE

      MESHVOLUME
    """
    def __eq__(self, other: object) -> bool: ...
    def __getstate__(self) -> int: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __init__(self, value: int) -> None: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    def __repr__(self) -> str: ...
    def __setstate__(self, state: int) -> None: ...
    def __str__(self) -> str: ...
    @property
    def name(self) -> str:
        """
        :type: str
        """
    @property
    def value(self) -> int:
        """
        :type: int
        """
    ANALYSE: netgen.libngpy._meshing.MeshingStep # value = <MeshingStep.ANALYSE: 1>
    MESHEDGES: netgen.libngpy._meshing.MeshingStep # value = <MeshingStep.MESHEDGES: 2>
    MESHSURFACE: netgen.libngpy._meshing.MeshingStep # value = <MeshingStep.MESHSURFACE: 4>
    MESHVOLUME: netgen.libngpy._meshing.MeshingStep # value = <MeshingStep.MESHVOLUME: 6>
    __members__: dict # value = {'ANALYSE': <MeshingStep.ANALYSE: 1>, 'MESHEDGES': <MeshingStep.MESHEDGES: 2>, 'MESHSURFACE': <MeshingStep.MESHSURFACE: 4>, 'MESHVOLUME': <MeshingStep.MESHVOLUME: 6>}
    pass
class NGDummyArgument():
    def __bool__(self) -> bool: ...
    pass
class NetgenGeometry():
    def RestrictH(self, arg0: Point3d, arg1: float) -> None: ...
    pass
class NgException(Exception, BaseException):
    pass
class Point2d():
    @staticmethod
    def __add__(*args, **kwargs) -> typing.Any: ...
    def __getitem__(self, arg0: int) -> float: ...
    @typing.overload
    def __init__(self, arg0: float, arg1: float) -> None: ...
    @typing.overload
    def __init__(self, arg0: tuple[float, float]) -> None: ...
    def __str__(self) -> str: ...
    @staticmethod
    def __sub__(*args, **kwargs) -> typing.Any: ...
    pass
class Point3d():
    @staticmethod
    def __add__(*args, **kwargs) -> typing.Any: ...
    def __getitem__(self, arg0: int) -> float: ...
    @typing.overload
    def __init__(self, arg0: float, arg1: float, arg2: float) -> None: ...
    @typing.overload
    def __init__(self, arg0: tuple) -> None: ...
    def __str__(self) -> str: ...
    @staticmethod
    def __sub__(*args, **kwargs) -> typing.Any: ...
    pass
class PointId():
    def __eq__(self, arg0: PointId) -> bool: ...
    def __hash__(self) -> int: ...
    def __init__(self, arg0: int) -> None: ...
    def __repr__(self) -> str: ...
    def __str__(self) -> str: ...
    @property
    def nr(self) -> int:
        """
        :type: int
        """
    pass
class SurfaceGeometry(NetgenGeometry):
    def GenerateMesh(self, quads: bool = True, nx: int = 10, ny: int = 10, flip_triangles: bool = False, bbbpts: list = [], bbbnames: list = [], hppts: list = [], hpbnd: list = []) -> Mesh: ...
    def __getstate__(self) -> tuple: ...
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def __init__(self, mapping: object) -> None: ...
    def __setstate__(self, arg0: tuple) -> None: ...
    pass
class Trafo():
    def __call__(self, arg0: Point3d) -> Point3d: ...
    @typing.overload
    def __init__(self, arg0: Point3d, arg1: Vec3d, arg2: float) -> None: 
        """
        a translation

        a rotation given by point on axes, direction of axes, angle
        """
    @typing.overload
    def __init__(self, arg0: Vec3d) -> None: ...
    def __mul__(self, arg0: Trafo) -> Trafo: ...
    pass
class Vec2d():
    def Norm(self) -> float: ...
    def __add__(self, arg0: Vec2d) -> Vec2d: ...
    def __eq__(self, arg0: Vec2d) -> bool: ...
    def __getitem__(self, arg0: int) -> float: ...
    @typing.overload
    def __init__(self, arg0: float, arg1: float) -> None: ...
    @typing.overload
    def __init__(self, arg0: tuple[float, float]) -> None: ...
    def __len__(self) -> int: ...
    def __mul__(self, arg0: float) -> Vec2d: ...
    def __neg__(self) -> Vec2d: ...
    def __rmul__(self, arg0: float) -> Vec2d: ...
    @staticmethod
    def __str__(*args, **kwargs) -> typing.Any: ...
    def __sub__(self, arg0: Vec2d) -> Vec2d: ...
    __hash__ = None
    pass
class Vec3d():
    def Norm(self) -> float: ...
    def __add__(self, arg0: Vec3d) -> Vec3d: ...
    def __eq__(self, arg0: Vec3d) -> bool: ...
    def __getitem__(self, arg0: int) -> float: ...
    @typing.overload
    def __init__(self, arg0: float, arg1: float, arg2: float) -> None: ...
    @typing.overload
    def __init__(self, arg0: tuple) -> None: ...
    def __len__(self) -> int: ...
    def __mul__(self, arg0: float) -> Vec3d: ...
    def __neg__(self) -> Vec3d: ...
    def __rmul__(self, arg0: float) -> Vec3d: ...
    def __str__(self) -> str: ...
    def __sub__(self, arg0: Vec3d) -> Vec3d: ...
    __hash__ = None
    pass
class _DebugParameters():
    @property
    def debugoutput(self) -> int:
        """
        :type: int
        """
    @debugoutput.setter
    def debugoutput(self, arg0: int) -> None:
        pass
    @property
    def haltexistingline(self) -> int:
        """
        :type: int
        """
    @haltexistingline.setter
    def haltexistingline(self, arg0: int) -> None:
        pass
    @property
    def haltface(self) -> int:
        """
        :type: int
        """
    @haltface.setter
    def haltface(self, arg0: int) -> None:
        pass
    @property
    def haltfacenr(self) -> int:
        """
        :type: int
        """
    @haltfacenr.setter
    def haltfacenr(self, arg0: int) -> None:
        pass
    @property
    def haltlargequalclass(self) -> int:
        """
        :type: int
        """
    @haltlargequalclass.setter
    def haltlargequalclass(self, arg0: int) -> None:
        pass
    @property
    def haltnode(self) -> int:
        """
        :type: int
        """
    @haltnode.setter
    def haltnode(self, arg0: int) -> None:
        pass
    @property
    def haltnosuccess(self) -> int:
        """
        :type: int
        """
    @haltnosuccess.setter
    def haltnosuccess(self, arg0: int) -> None:
        pass
    @property
    def haltoverlap(self) -> int:
        """
        :type: int
        """
    @haltoverlap.setter
    def haltoverlap(self, arg0: int) -> None:
        pass
    @property
    def haltsegment(self) -> int:
        """
        :type: int
        """
    @haltsegment.setter
    def haltsegment(self, arg0: int) -> None:
        pass
    @property
    def haltsegmentp1(self) -> int:
        """
        :type: int
        """
    @haltsegmentp1.setter
    def haltsegmentp1(self, arg0: int) -> None:
        pass
    @property
    def haltsegmentp2(self) -> int:
        """
        :type: int
        """
    @haltsegmentp2.setter
    def haltsegmentp2(self, arg0: int) -> None:
        pass
    @property
    def haltsuccess(self) -> int:
        """
        :type: int
        """
    @haltsuccess.setter
    def haltsuccess(self, arg0: int) -> None:
        pass
    @property
    def slowchecks(self) -> int:
        """
        :type: int
        """
    @slowchecks.setter
    def slowchecks(self, arg0: int) -> None:
        pass
    @property
    def write_mesh_on_error(self) -> bool:
        """
        :type: bool
        """
    @write_mesh_on_error.setter
    def write_mesh_on_error(self, arg0: bool) -> None:
        pass
    pass
def GetTransformation() -> Trafo:
    pass
def ImportMesh(filename: str) -> Mesh:
    """
    Import mesh from other file format, supported file formats are:
     Neutral format (*.mesh, *.emt)
     Surface file (*.surf)
     Universal format (*.unv)
     Olaf format (*.emt)
     Tet format (*.tet)
     Pro/ENGINEER format (*.fnf)
    """
@typing.overload
def Pnt(arg0: float, arg1: float) -> Point2d:
    pass
@typing.overload
def Pnt(arg0: float, arg1: float, arg2: float) -> Point3d:
    pass
@typing.overload
def Pnt(arg0: numpy.ndarray[numpy.float64]) -> object:
    pass
def ReadCGNSFile(filename: os.PathLike, base: int = 1) -> tuple[Mesh, list[str], list[pyngcore.pyngcore.Array_D_S], list[int]]:
    """
    Read mesh and solution vectors from CGNS file
    """
def SetMessageImportance(arg0: int) -> int:
    pass
def SetParallelPickling(arg0: bool) -> None:
    pass
def SetTestoutFile(arg0: str) -> None:
    pass
@typing.overload
def SetTransformation(arg0: Trafo) -> None:
    pass
@typing.overload
def SetTransformation(dir: int = 0, angle: float = 0) -> None:
    pass
@typing.overload
def SetTransformation(p0: Point3d, ex: Vec3d, ey: Vec3d, ez: Vec3d) -> None:
    pass
@typing.overload
def Vec(arg0: float, arg1: float) -> Vec2d:
    pass
@typing.overload
def Vec(arg0: float, arg1: float, arg2: float) -> Vec3d:
    pass
@typing.overload
def Vec(arg0: numpy.ndarray[numpy.float64]) -> object:
    pass
def WriteCGNSFile(mesh: Mesh, filename: os.PathLike, names: list[str], values: list[pyngcore.pyngcore.Array_D_S], locations: list[int]) -> None:
    """
    Write mesh and solution vectors to CGNS file, possible values for locations:
          Vertex     = 0
          EdgeCenter = 1
          FaceCenter = 2
          CellCenter = 3
          
    """
def _GetStatus() -> tuple:
    pass
def _PushStatus(arg0: str) -> None:
    pass
def _Redraw(blocking: bool = False, fr: float = 25) -> bool:
    """
    Redraw all

    Parameters:

    blocking : bool
      input blocking

    fr : double
      input framerate
    """
def _SetThreadPercentage(arg0: float) -> None:
    pass
debugparam: netgen.libngpy._meshing._DebugParameters
